#include "modbus_reg_helper.hpp"

#include <cstddef>

union float_uint32
{
	uint32_t uint32me;
	float    float32me;
};

void mb_reg_help::set_16b_in_32b(uint8_t bytenum, uint16_t input, uint32_t* bigval)
{
	if (NULL == bigval)
	{
		return;
	}
	
	uint32_t local32 = *bigval;
	uint32_t input32 = input;
	switch (bytenum)
	{
		case 0:
			local32 &= 0xFFFF0000;
			local32 |= input32;
			break;
		case 1:
			local32 &= 0x0000FFFF;
			local32 |= input32 << 16;
			break;
	}
	*bigval = local32;
}

void mb_reg_help::set_16b_in_float(uint8_t bytenum, uint16_t input, float* bigval)
{
	float_uint32 convert;
	convert.float32me = *bigval;
	set_16b_in_32b(bytenum, input, &convert.uint32me);
	*bigval = convert.float32me;
}

void mb_reg_help::get_16b_in_32b(uint8_t bytenum, uint16_t* out, uint32_t bigval)
{
	if (NULL == out)
	{
		return;
	}
	
	switch (bytenum)
	{
		case 0:
			*out = bigval & 0xFFFF;
			break;
		case 1:
			*out = bigval >> 16;
			break;
	}
}

void mb_reg_help::get_16b_in_float(uint8_t bytenum, uint16_t* out, float bigval)
{
	float_uint32 convert;
	convert.float32me = bigval;
	get_16b_in_32b(bytenum, out, convert.uint32me);
}