#ifndef MODBUS_REG_HELPER_HPP
#define MODBUS_REG_HELPER_HPP

#include <cstdint>

class mb_reg_help {
public:

	//! \brief sets upper or lower 16b in a 32b value
	//! \param[in] bytenum 0 -> LSB/LO, 1 -> MSB/HI
	//! \param[in] input 16bit to set
	//! \param[inout] bigval value that will be manipulated
	static void set_16b_in_32b(uint8_t bytenum, uint16_t input, uint32_t* bigval);
	
	//! \brief sets upper or lower 16b in a 32b float value
	//! \param[in] bytenum 0 -> LSB/LO, 1 -> MSB/HI
	//! \param[in] input 16bit to set
	//! \param[inout] bigval value that will be manipulated
	static void set_16b_in_float(uint8_t bytenum, uint16_t input, float* bigval);
	
	//! \brief gets upper or lower 16b in a 32b value
	//! \param[in] bytenum 0 -> LSB/LO, 1 -> MSB/HI
	//! \param[out] out 16bit to read
	//! \param[in] bigval value that will be read
	static void get_16b_in_32b(uint8_t bytenum, uint16_t* out, uint32_t bigval);
	
	//! \brief gets upper or lower 16b in a 32b float value
	//! \param[in] bytenum 0 -> LSB/LO, 1 -> MSB/HI
	//! \param[out] out 16bit to read
	//! \param[in] bigval value that will be read
	static void get_16b_in_float(uint8_t bytenum, uint16_t* out, float bigval);

};

#endif // MODBUS_REG_HELPER_HPP