#ifndef CPU_TYPES_H
#define CPU_TYPES_H

enum cpu_types {
	cpu_type_unknown = 0,
	cpu_type_STM32L010K8 = 1,  //!< STM32L010 with 64k flash, 32 Pins, no USART2 on PA10/9
	cpu_type_to16b = 60000,
};

// see https://crccalc.com/
enum crc_types {
	crc_type_unknown = 0,
	crc_type_crc32_network = 1, //!< Poly: 0x04C11DB7, Init: 0xFFFFFFFF, Reflect: yes, XorOut: 0xFFFFFFFF
};

struct cpu_types_supported {
	uint32_t fw_vers;  //!< firmware version in bytes
	uint16_t num;      //!< num of cpu types in types
	uint16_t typesize; //!< sizeof(cpu_types)
	cpu_types types[]; //!< list of cpu types (supported by this FW)
};

#endif // CPU_TYPES_H