#ifndef CONFIG_DATA_ADDR_HPP
#define CONFIG_DATA_ADDR_HPP

#include "periph/eeprom.hpp"

#define ADDR_FIRSTBLOOD     (EEPROM_START_ADDR + 0x00) // for BL and FW (BL uses default modbus, FW sets EEPROM initial)
#define ADDR_MODBUS         (EEPROM_START_ADDR + 0x04) // for BL and FW
#define ADDR_BL_VERSION     (EEPROM_START_ADDR + 0x08) // for BL
#define ADDR_FW_VERSION     (EEPROM_START_ADDR + 0x0C) // for BL and FW
#define ADDR_FW_START_ADDR  (EEPROM_START_ADDR + 0x10) // for BL
#define ADDR_FW_SIZE        (EEPROM_START_ADDR + 0x14) // for BL
#define ADDR_FW_CRC32       (EEPROM_START_ADDR + 0x18) // for BL

#define ADDR_BARREL_DIA_BOT (EEPROM_START_ADDR + 0x20) // for FW
#define ADDR_BARREL_DIA_TOP (EEPROM_START_ADDR + 0x24)
#define ADDR_BARREL_HEIGHT  (EEPROM_START_ADDR + 0x28)
#define ADDR_BARREL_ADC_ZER (EEPROM_START_ADDR + 0x2C)
#define ADDR_BARREL_ADC_FUL (EEPROM_START_ADDR + 0x30)
#define ADDR_BARREL_OFFSET  (EEPROM_START_ADDR + 0x34)
#define ADDR_BARREL_POLY0   (EEPROM_START_ADDR + 0x38)
#define ADDR_BARREL_POLY1   (EEPROM_START_ADDR + 0x3C)
#define ADDR_BARREL_POLY2   (EEPROM_START_ADDR + 0x40)

#endif // CONFIG_DATA_ADDR_HPP