#ifndef MB_CALLBACK_HOLD
#define MB_CALLBACK_HOLD

#include "i_mb_callback.hpp"

#include "device\water_barrel.hpp"

#include "modbus\modbus.hpp"

#include <cstddef>

class mb_callback_hold : public i_mb_callback {
public:

	mb_callback_hold();
	
	mb_err init(barrel_calibdata* barrel_calib, modbus* mb_inst, mb_setting* mb_settings);
	
	//! \brief callback for writung In/Hold Registers and Coils
	//! \param[inout] buf 16bit value to write
	//! \param[in] address address of register/input/coil to R/W
	//! \return modbus exception code @ref mb_exc
	virtual mb_err call_write(uint16_t buf, uint16_t address);
	
	//! \brief callback for reading In/Hold Registers and Coils/Inputs
	//! \param[inout] buf pointer to 16bit value to store read value to
	//! \param[in] address address of register/input/coil to R/W
	//! \return modbus exception code @ref mb_exc
	virtual mb_err call_read(uint16_t *buf, uint16_t address);
	
private:

	barrel_calibdata* m_barrel_calib;
	modbus*           m_mb_inst; 
	mb_setting*       m_mb_settings;
};

#endif//MB_CALLBACK_HOLD