#include "nvic.h"

#include <stdint.h>

static volatile unsigned int * const NVIC_SET_ENABLE   = (unsigned int *)0xE000E100;
static volatile unsigned int * const NVIC_CLEAR_ENABLE = (unsigned int *)0xE000E180;
static volatile unsigned int * const NVIC_CLEAR_PEND   = (unsigned int *)0xE000E280;
static volatile uint8_t * const NVIC_PRIORITY = (uint8_t *)0xE000E400;

void nvic_enable_irq(IRQn_Type irq_nbr, unsigned int preempt_prio, unsigned int sub_prio){
	
	//Zuerst Prio setzen
	uint8_t prio = preempt_prio << 4;
	prio |= sub_prio & 0xF;
	NVIC_PRIORITY[irq_nbr] = prio;
	
	//IRQ danach einschalten
	unsigned int arr_index = irq_nbr/32;
	unsigned int shift = irq_nbr - (arr_index*32);
	NVIC_SET_ENABLE[arr_index] = 1 << shift;
}

void nvic_disable_irq(IRQn_Type irq_nbr){

	unsigned int arr_index = irq_nbr/32;
	unsigned int shift = irq_nbr - (arr_index*32);
	NVIC_CLEAR_ENABLE[arr_index] = 1 << shift;
}

void nvic_pending_clear(IRQn_Type irq_nbr){

	unsigned int arr_index = irq_nbr/32;
	unsigned int shift = irq_nbr - (arr_index*32);
	NVIC_CLEAR_PEND[arr_index] = 1 << shift;
}