#ifndef I_TIMER_POLL_HPP
#define I_TIMER_POLL_HPP

#include <cstdint>

// a timer interface for a timer that is pollable for slow timings in ms range

enum class timer_poll_err {
	SUCCESS,
	ERR_ARGS,
	ERR_INIT,
};

struct tim_poll_obj {
	uint32_t startval;
	uint32_t endval;
	uint32_t time_ms;
};

class i_timer_poll {
public:
	
	//! \brief starts a timer obj
	//! \param idx object handle
	//! \param time_ms time in m2 to wait
	//! \return @ref timer_poll_err
	virtual timer_poll_err start(tim_poll_obj* idx, uint32_t time_ms) = 0;
	
	//! \brief checks if time is over
	//! \param idx object handle
	//! \param expired expired or not
	//! \return @ref timer_poll_err
	virtual timer_poll_err check_expiry(tim_poll_obj* idx, bool* expired) = 0;
};

#endif // I_TIMER_POLL_HPP