#include "i_pio.hpp"

#include <cstddef>

pio_set::pio_set() :
	m_pio_inst(NULL),
	m_config(NULL)
{
}
	
pioerr pio_set::init(i_pio* pio_inst, const pio_pin_set* config)
{
	m_pio_inst = NULL;
	if ((NULL == pio_inst) || (NULL == config) || (NULL == config->pin))
	{
		return pioerr::ERR_ARGS;
	}
	
	m_pio_inst = pio_inst;
	m_config   = config;
	
	m_pio_inst->init(config->pin);
	disable(); // disable at default
	
	return pioerr::SUCCESS;
}
	
pioerr pio_set::enable(void)
{
	
	if (NULL == m_pio_inst)
	{
		return pioerr::ERR_INIT;
	}
	
	pioerr err;
	
	if (m_config->enableIsHigh)
	{
		err = m_pio_inst->set(m_config->pin);
	}
	else
	{
		err = m_pio_inst->clear(m_config->pin);
	}
	
	return err;
}
	
pioerr pio_set::disable(void)
{
	
	if (NULL == m_pio_inst)
	{
		return pioerr::ERR_INIT;
	}
	
	pioerr err;
	
	if (m_config->enableIsHigh)
	{
		err = m_pio_inst->clear(m_config->pin);
	}
	else
	{
		err = m_pio_inst->set(m_config->pin);
	}
	
	return err;
}